/**
 * @file
 * Snippet manager behaviors.
 */

(function (Drupal, $, once) {

  'use strict';

  Drupal.behaviors.snippetManager = {
    attach(context) {

      let textArea = $(once('snippet_manager_editor', 'textarea[data-codemirror]', context));
      if (textArea.length !== 1) {
        return;
      }

      let doc = $('.CodeMirror')[0].CodeMirror.getDoc();

      // Insert variables into editor.
      $('[data-drupal-selector="snippet-variable"]').click(function () {
        doc.replaceSelection('{{ ' + $(this).text() + ' }}', doc.getCursor());
        return false;
      });

    }
  };

}(Drupal, jQuery, once));
